package com.ynet.life.sujrb.action;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.imageio.plugins.bmp.BMPImageReader;
import com.sun.imageio.plugins.gif.GIFImageReader;
import com.sun.imageio.plugins.jpeg.JPEGImageReader;
import com.sun.imageio.plugins.png.PNGImageReader;
import com.ynet.gene.core.GENEException;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.Trace;
import com.ynet.life.sujrb.img.AnimatedGifEncoder;
import com.ynet.life.sujrb.img.GifDecoder;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.WritableRaster;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Blob;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.MemoryCacheImageInputStream;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_sujrb_action.jar:com/ynet/life/sujrb/action/IconDownloadAction.class */
public class IconDownloadAction extends HttpServlet {
    private String SELECT_SQL = "select CIP_ICON from PB_CST_ICON where CIP_CSTNO = ?";

    protected void doGet(HttpServletRequest request, HttpServletResponse response) {
        Connection connection = null;
        try {
            try {
                try {
                    try {
                        String customerId = request.getParameter("customerId");
                        Connection connection2 = LifeDBAccess.getConnection("ebank_ds");
                        connection = connection2;
                        PreparedStatement ps = connection2.prepareStatement(this.SELECT_SQL);
                        ps.setString(1, customerId);
                        ResultSet rs = ps.executeQuery();
                        while (rs.next()) {
                            Blob blob = rs.getBlob(1);
                            InputStream inputStream = blob.getBinaryStream();
                            InputStream inputStream1 = blob.getBinaryStream();
                            InputStream inputStream2 = blob.getBinaryStream();
                            Trace.logInfo("LifeAction", "生成头像图片开始。。。");
                            String urlPath = String.valueOf(getServletContext().getRealPath("/")) + "/personalImgs/";
                            Trace.logInfo("LifeAction", "路径为：".concat(String.valueOf(urlPath)));
                            File fileImg = new File(urlPath);
                            if (!fileImg.exists()) {
                                fileImg.mkdir();
                            }
                            String fileType = getImageType(inputStream2);
                            ServletOutputStream outputStream = response.getOutputStream();
                            response.setContentType("image/jpeg");
                            response.setHeader("Pragma", "No-cache");
                            response.setHeader("Cache-Control", "no-cache");
                            response.setDateHeader("Expires", 0L);
                            if (".gif".equals(fileType)) {
                                GifDecoder decoder = new GifDecoder();
                                decoder.read(inputStream1);
                                AnimatedGifEncoder e = new AnimatedGifEncoder();
                                e.start(outputStream);
                                e.setRepeat(decoder.getLoopCount());
                                e.setTransparent(Color.BLACK);
                                int n = decoder.getFrameCount();
                                for (int i = 0; i < n; i++) {
                                    BufferedImage targetFrame = resize(decoder.getFrame(i), 65, 69);
                                    e.setDelay(decoder.getDelay(i));
                                    e.addFrame(targetFrame);
                                }
                                e.finish();
                            } else if (".png".equals(fileType)) {
                                ImageIO.write(resize(ImageIO.read(inputStream1), 65, 69), "png", outputStream);
                            } else {
                                BufferedImage image = ImageIO.read(inputStream1);
                                BufferedImage tag = new BufferedImage(65, 69, 1);
                                tag.getGraphics().drawImage(image.getScaledInstance(65, 69, 4), 0, 0, (ImageObserver) null);
                                JPEGCodec.createJPEGEncoder(outputStream).encode(tag);
                            }
                            Trace.logInfo("LifeAction", "生成头像图片结束。。。");
                            outputStream.flush();
                            outputStream.close();
                            inputStream.close();
                            inputStream1.close();
                            inputStream2.close();
                        }
                        try {
                            LifeDBAccess.releaseConnection(connection);
                        } catch (GENEException e2) {
                            Trace.logError("LifeAction", "数据库上传文件异常GENE", e2);
                        }
                    } catch (FileNotFoundException e3) {
                        Trace.logError("LifeAction", "数据库上传文件异常FILE", e3);
                        try {
                            LifeDBAccess.releaseConnection(connection);
                        } catch (GENEException e4) {
                            Trace.logError("LifeAction", "数据库上传文件异常GENE", e4);
                        }
                    }
                } catch (GENEException e5) {
                    Trace.logError("LifeAction", "数据库上传文件异常GENE", e5);
                    try {
                        LifeDBAccess.releaseConnection(connection);
                    } catch (GENEException e6) {
                        Trace.logError("LifeAction", "数据库上传文件异常GENE", e6);
                    }
                }
            } catch (IOException e7) {
                Trace.logError("LifeAction", "数据库上传文件异常FILE", e7);
                try {
                    LifeDBAccess.releaseConnection(connection);
                } catch (GENEException e8) {
                    Trace.logError("LifeAction", "数据库上传文件异常GENE", e8);
                }
            } catch (SQLException e9) {
                Trace.logError("LifeAction", "数据库上传文件异常SQL", e9);
                try {
                    LifeDBAccess.releaseConnection(connection);
                } catch (GENEException e10) {
                    Trace.logError("LifeAction", "数据库上传文件异常GENE", e10);
                }
            }
        } catch (Throwable th) {
            try {
                LifeDBAccess.releaseConnection(connection);
            } catch (GENEException e11) {
                Trace.logError("LifeAction", "数据库上传文件异常GENE", e11);
            }
            throw th;
        }
    }

    private static BufferedImage resize(BufferedImage source, int targetW, int targetH) {
        BufferedImage target;
        int type = source.getType();
        double sx = targetW / source.getWidth();
        double sy = targetH / source.getHeight();
        if (sx < sy) {
            targetW = (int) (sx * source.getWidth());
        } else {
            targetH = (int) (sy * source.getHeight());
        }
        if (type == 0) {
            ColorModel cm = source.getColorModel();
            WritableRaster raster = cm.createCompatibleWritableRaster(targetW, targetH);
            boolean alphaPremultiplied = cm.isAlphaPremultiplied();
            target = new BufferedImage(cm, raster, alphaPremultiplied, (Hashtable) null);
        } else {
            target = new BufferedImage(targetW, targetH, type);
        }
        Graphics2D g = target.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR);
        g.drawRenderedImage(source, AffineTransform.getScaleInstance(sx, sy));
        g.dispose();
        return target;
    }

    public static String getImageType(InputStream fis) throws IOException {
        int leng = fis.available();
        BufferedInputStream buff = new BufferedInputStream(fis);
        byte[] mapObj = new byte[leng];
        buff.read(mapObj, 0, leng);
        String type = "";
        ByteArrayInputStream bais = null;
        MemoryCacheImageInputStream mcis = null;
        try {
            bais = new ByteArrayInputStream(mapObj);
            MemoryCacheImageInputStream memoryCacheImageInputStream = new MemoryCacheImageInputStream(bais);
            mcis = memoryCacheImageInputStream;
            Iterator itr = ImageIO.getImageReaders(memoryCacheImageInputStream);
            while (itr.hasNext()) {
                ImageReader reader = (ImageReader) itr.next();
                if (reader instanceof GIFImageReader) {
                    type = ".gif";
                } else if (reader instanceof JPEGImageReader) {
                    type = ".jpg";
                } else if (reader instanceof PNGImageReader) {
                    type = ".png";
                } else if (reader instanceof BMPImageReader) {
                    type = ".bmp";
                }
            }
            try {
                bais.close();
            } catch (IOException unused) {
            }
            try {
                mcis.close();
            } catch (IOException unused2) {
            }
            return type;
        } catch (Throwable th) {
            if (bais != null) {
                try {
                    bais.close();
                } catch (IOException unused3) {
                }
            }
            if (mcis != null) {
                try {
                    mcis.close();
                } catch (IOException unused4) {
                }
            }
            throw th;
        }
    }
}
